/*
 *  Vazaar
 *  file: vazaar.h
 *
 *
 *  Copyright (C) 2005 Tomás Vírseda <kaskaras@yahoo.es>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _VAZAAR_H
#define _VAZAAR_H
//#include <gconf/gconf-client.h>

#define I18N_WASTEBASKET (_("Wastebasket"))
#define I18N_SEARCH (_("Search"))

typedef struct _Vazaar Vazaar;
typedef struct _MIMEIconsCache MIMEIconsCache;
typedef struct _ItemsCache ItemsCache;
	
struct _Vazaar {
    /*
     * Glade XML 
     */
    GladeXML       *xml;
	GladeXML		*license_win;
	
    /*
     * GConf
     */	
	//GConfClient		*client;
	
    /*
     * GUI 
     */
    GtkWidget		*window,		/* Main window			*/
    				*treecat,		/* Categories treeview  */
					*frmwastebasket,	/* wastebasket's operations container */
    				*treeitem,		/* Item treeview		*/
					*frmitems,		/* Container for treeitem */
					*frmcats,		/* Container for treecat */
    				*statusbar,		/* Status bar			*/
		/*
		 * Menu bar (nothing yet)
		 */
	
		/*
		 * Categories toolbar 
		 */
     				*addcat,
					*editcat,
					*delcat,
				   	*expcat,
					*collcat,
					*wastebasket,
					*emptybasket,
		/*
		 * Item toolbar 
		 */
                   *additem,
                   *edititem,
                   *delitem,
				   *infoitem,
				   *firstitem,
				   *previtem,
				   *refreshitem,
				   *nextitem,
				   *lastitem,	
					*viewcat,				   
					*fullscreen,
		/*
		 * H/V Panned 
		 */
					*hpcat,	/* Hor. paned */
					*vpitem,	/* Vert. paned */
					*vboxitems,	/* VBox Items */
    				

		/*
		 * Item Info
		 */
					*frameInfo,			/* GtkExpander */
					*itemInfoIcon,		/* GtkImage */
					*itemInfoId,		/* GtkEntry */
					*itemInfoName,		/* GtkEntry */
					*itemInfoDesc,		/* GtkTextView */
					*itemInfoMIME,		/* GtkEntry */
					*itemInfoApp,		/* GtkEntry */
					*itemInfoLaunch,	/* GtkButton */
					*itemInfoSDate,		/* GtkEntry */
					*itemInfoMDate;		/* GtkEntry */
	
	/* Others */
	gboolean		force_reload;
	gchar			*citem;		/* Current item shown (item->id) */
	GList			*current_items;	/* GList ID items in current category */
	
	GList			*mime_icon_cache;
};

struct _MIMEIconsCache {
	gchar		*mime;
	GdkPixbuf	*icon;
};

struct _ItemsCache {
	gchar		*id;
	gpointer	*content;
};

#define BYTES_TO_PROCESS 256

#define GLADE_VAZAAR_PROJECT_FILE PACKAGE_DATA_DIR"/vazaar/vazaar.glade"
#define GLADE_VAZAAR_MAIN_WIN				"winMain"
#define GLADE_VAZAAR_WASTEBASKET_CONTAINER	"frmWastebasket"
#define GLADE_VAZAAR_VAZAAR_WIN				"vazaarWin"
#define GLADE_VAZAAR_TREEVIEW_CATEGORIES	"trvVazaarCat"
#define GLADE_VAZAAR_TREEVIEW_ITEMS			"trvVazaarItems"
#define GLADE_VAZAAR_HPANED					"hpCategorias"
#define GLADE_VAZAAR_VPANED					"vpNotas"
#define GLADE_VAZAAR_STATUSBAR				"statusBarVazaar"
#define GLADE_VAZAAR_ITEMDESC				"txvItemDesc"
#define GLADE_VAZAAR_FRMCATS				"frmCats"
#define GLADE_VAZAAR_FRMITEMS				"frmItems"

/* Categories toolbar */
#define GLADE_VAZAAR_TLB_ADDCAT				"tlbAddCat"
#define GLADE_VAZAAR_TLB_EDITCAT			"tlbEditCat"
#define GLADE_VAZAAR_TLB_DELCAT				"tlbDelCat"
#define	GLADE_VAZAAR_TLB_EXPCAT				"tlbExpandCat"
#define	GLADE_VAZAAR_TLB_COLLCAT			"tlbCollapseCat"
#define GLADE_VAZAAR_TLB_WASTEBASKET		"wastebasket"
#define GLADE_VAZAAR_TLB_EMPTY_WASTEBASKET	"emptybasket"

/* Items toolbar */
#define GLADE_VAZAAR_TLB_ADDITEM			"tlbItemAdd"
#define GLADE_VAZAAR_TLB_EDITITEM			"tlbItemEdit"
#define GLADE_VAZAAR_TLB_DELITEM			"tlbItemDel"
#define GLADE_VAZAAR_TLB_INFOITEM			"tgbItemInfo"
#define GLADE_VAZAAR_TLB_VIEWCAT			"tgbViewCat"
#define GLADE_VAZAAR_TLB_FINDITEM			"tlbSearchItem"
#define GLADE_VAZAAR_TLB_FIRSTITEM			"tlbItemFirst"
#define GLADE_VAZAAR_TLB_PREVITEM			"tlbItemPrevious"
#define GLADE_VAZAAR_TLB_REFRESHITEM		"tlbItemRefreh"
#define GLADE_VAZAAR_TLB_NEXTITEM			"tlbItemNext"
#define GLADE_VAZAAR_TLB_LASTITEM			"tlbItemLast"
#define GLADE_VAZAAR_TLB_FULLSCREEN			"tgbFullscreen"	

/* Panel Info Item */
#define GLADE_VAZAAR_INFOITEM_FRAME			"ItemInfo"
#define	GLADE_VAZAAR_INFOITEM_ICON			"itemInfoIcon"
#define	GLADE_VAZAAR_INFOITEM_ID			"itemInfoID"
#define	GLADE_VAZAAR_INFOITEM_NAME			"itemInfoName"
#define	GLADE_VAZAAR_INFOITEM_DESC			"itemInfoDesc"
#define	GLADE_VAZAAR_INFOITEM_MIME			"itemInfoMIME"
#define	GLADE_VAZAAR_INFOITEM_DEFAPP		"itemInfoDefApp"
#define	GLADE_VAZAAR_INFOITEM_LAUNCH		"itemInfoLaunchApp"
#define	GLADE_VAZAAR_INFOITEM_SDATE			"itemInfoSDate"
#define	GLADE_VAZAAR_INFOITEM_MDATE			"itemInfoMDate"

#define GLADE_VAZAAR_VBOX_ITEMS				"vboxItems"

/* Signals */
#define VAZAAR_MENU_ABOUT_SIGNAL			"on_about_activate"
#define VAZAAR_MENU_QUIT_SIGNAL				"on_quit_activate"
#define VAZAAR_MENU_PREFERENCES_SIGNAL		"on_preferences_activate"
#define VAZAAR_MENU_ADDCAT_SIGNAL			"on_add_category_activate"
#define VAZAAR_MENU_EDITCAT_SIGNAL			"on_edit_category_activate"
#define VAZAAR_MENU_DELCAT_SIGNAL			"on_delete_category_activate"
#define VAZAAR_MENU_ADDITEM_SIGNAL			"on_add_new_item_activate"
#define VAZAAR_MENU_EDITITEM_SIGNAL			"on_edit_item_activate"
#define VAZAAR_MENU_DELITEM_SIGNAL			"on_delete_item_activate"
#define VAZAAR_MENU_INFOITEM_SIGNAL			"on_show_item_info_activate"
#define VAZAAR_MENU_SHOWCATS_SIGNAL			"on_show_categories_panel_activate"

#define VAZAAR_QUIT_SIGNAL					"on_mainWin_delete_event"
#define VAZAAR_CONFIGURE_SIGNAL				"on_mainWin_configure_event"
#define VAZAAR_TREECAT_ROW_CHANGED_SIGNAL	"on_trvVazaarCat_cursor_changed"

	/* Item toolbar signals */
#define VAZAAR_BTNADDITEM_CLICKED_SIGNAL	"on_tlbItemAdd_clicked"
#define VAZAAR_BTNEDITITEM_CLICKED_SIGNAL	"on_tlbItemEdit_clicked"
#define VAZAAR_BTNDELITEM_CLICKED_SIGNAL	"on_tlbItemDel_clicked"
#define VAZAAR_BTNVIEWCAT_TOGGLED_SIGNAL	"on_tgbViewCat_toggled"
#define VAZAAR_BTNINFOITEM_CLICKED_SIGNAL	"on_tgbItemInfo_toggled"
#define VAZAAR_BTNFIRSTITEM_CLICKED_SIGNAL	"on_tlbItemFirst_clicked"
#define VAZAAR_BTNPREVIOUSITEM_CLICKED_SIGNAL	"on_tlbItemPrevious_clicked"
#define VAZAAR_BTNREFRESITEM_CLICKED_SIGNAL	"on_tlbItemRefresh_clicked"
#define VAZAAR_BTNNEXTITEM_CLICKED_SIGNAL	"on_tlbItemNext_clicked"
#define VAZAAR_BTNLASTITEM_CLICKED_SIGNAL	"on_tlbItemLast_clicked"
#define VAZAAR_BTNFULLSCREEN_TOGGLE_SIGNAL	"on_tgbFullscreen_toggled"

	/* Info Panel signals */
#define VAZAAR_ITEM_LAUNCH_DEFAPP_SIGNAL	"on_itemInfoLaunchApp_clicked"

	/* Categories toolbar signals */
#define VAZAAR_INFOPANEL_EXPANDER_ACTIVATED	"on_expItemInfo_activate"
#define VAZAAR_BTNADDCAT_CLICKED_SIGNAL		"on_tlbAddCat_clicked"
#define VAZAAR_BTNEDITCAT_CLICKED_SIGNAL	"on_tlbEditCat_clicked"
#define VAZAAR_BTNDELCAT_CLICKED_SIGNAL		"on_tlbDelCat_clicked"
#define VAZAAR_BTNEXPCAT_CLICKED_SIGNAL		"on_tlbExpandCat_clicked"
#define VAZAAR_BTNCOLCAT_CLICKED_SIGNAL		"on_tlbCollapseCat_clicked"
#define VAZAAR_WASTEBASKET_TOGGLED_SIGNAL	"on_wastebasket_toggled"
#define VAZAAR_EMPTYBASKET_CLICKED_SIGNAL	"on_emptybasket_clicked"
#define TRVITEM_CURSOR_CHANGED_SIGNAL		"on_trvVazaarItems_cursor_changed"

enum {
	T_LOG,
	T_MESSAGE,
	T_WARNING,
	T_CRITICAL,
	T_ERROR,
	T_DEBUG
};

void
vazaar_gui_wastebasket_toggled			(	GtkWidget *nothing, 
											Vazaar *this);

void
vazaar_gui_emptybasket_clicked			(	GtkWidget *nothing, 
											Vazaar *this);

void vazaar_gui_first_time_wizard (Vazaar *app);

Vazaar*
vazaar_gui_vazaar_new					();

void            
vazaar_gui_vazaar_destroy				(	Vazaar *);

void            
vazaar_gui_vazaar_show					(	Vazaar *);

void            
vazaar_gui_vazaar_connect_all_signals	(	Vazaar *);

xmlNodePtr      
vazaar_xml_vazaar_create				();

xmlNodePtr      
vazaar_xml_categories_create			();

xmlNodePtr      
vazaar_xml_items_create					();

gchar*
vazaar_xml_vazaardoc_get				();


gchar*
vazaar_xml_catdoc_get					();

gchar*
vazaar_xml_itemdoc_get					();

gint           
vazaar_xml_vazaar_savefile				();

gchar*
vazaar_cmd_item_md5sum_get				(	GString *);

GdkPixbuf*
vazaar_cmd_pixbuf_scale_get				(	GdkPixbuf *,
					    					gint,
					    					gint);
						
gchar*
vazaar_cmd_item_get_mime_supertype		(const gchar *);

const gchar *
vazaar_cmd_appdir_get					();

const gchar *
vazaar_cmd_storedir_get				();

void 
on_tlbItemFirst_clicked			(	GtkWidget *,
											Vazaar	*);
void 
on_tlbItemPrevious_clicked			(	GtkWidget *,
											Vazaar	*);
void 
on_tlbItemRefresh_clicked			(	GtkWidget *,
											Vazaar	*);
void 
on_tlbItemNext_clicked				(	GtkWidget *,
											Vazaar	*);
void 
on_tlbItemLast_clicked				(	GtkWidget *,
											Vazaar	*);											
GtkWidget*  
vazaar_hig_dialog_new					(	GtkWindow *, 
											const char *, 
											const char *, 
											const char *, 
											gboolean);

gint      
vazaar_gui_show_dialog					(	GtkWidget *, 
											gchar *, 
											gchar *, 
											gchar *);

gint            
vazaar_cmd_strings_compare				(	gchar *, 
											gchar *);

void            
vazaar_gui_item_content_delete			(	Vazaar *);

void			
vazaar_gui_expand_categories			(	Vazaar *);

void			
vazaar_gui_collapse_categories			(	Vazaar *);

void			
vazaar_gui_vazaar_init_drag_and_drop 	(	Vazaar *);

gchar*
vazaar_cmd_get_current_date 			();

void
vazaar_gui_infopanel_activated 			(	GtkWidget *nothing, 
											Vazaar *this);

GList *
vazaar_cmd_get_files_from_dir 			(	const gchar *directory);

GdkPixbuf *
get_pixbuf_from_mime_type 				(	const gchar *mime_type, 
											gint icon_size);

static
GdkPixbuf *
load_icon_file							(	gchar *filename, 
											guint base_size,
											guint nominal_size);

GdkPixbuf *
scale_icon								(	GdkPixbuf	*pixbuf,	
											gint		size);

static gchar **
uri_list_extract_uris					(	const gchar *uri_list);

static void       
treeitem_drag_data_received_cb			(	GtkWidget			*widget,
											GdkDragContext		*context,
											int					x,
							  				int					y,
											GtkSelectionData	*data,
											guint				info,
											guint				time,
											Vazaar				*app);

void 
vazaar_cmd_mimeiconscache_fill 			(	Vazaar *app);
void vazaar_cmd_mime_add_icon_to_cache	(	Vazaar *app, 
											gchar *mime);
GdkPixbuf *load_mime_icon				(	Vazaar *app, 
											gchar *mime);
gboolean vazaar_cmd_mime_is_cached 		(	Vazaar *app, 
											gchar *mime);
gboolean vazaar_cmd_check_gnomevfs_result	(	GtkWidget *window, 
												gint res);
												
gchar *
vazaar_gui_get_current_category			(	Vazaar	*app);

gchar *
vazaar_gui_get_current_item				(	Vazaar	*app);

gboolean 
vazaar_gui_category_is_wastebasket		(	Vazaar *app);

void
vazaar_gui_fullscreen_mode 				(	GtkWidget *nothing, 
											Vazaar *app);
										
void 
vazaar_gui_toolbar_items_toggle			(	Vazaar *app);
#endif
